Subject: Re: bug#63187: 30.0.50; Tail of longer lines painted after end of nearby lines on macOS

From: Po Lu <[email-masked]>
Date: Mon, 01 May 2023 21:18:31 +0800

Eli Zaretskii <[email-masked]> writes:

>> Cc: [email-masked]
>> Date: Mon, 01 May 2023 07:58:26 +0800
>> From:  Po Lu via "Bug reports for GNU Emacs,
>>  the Swiss army knife of text editors" <[email-masked]>
>> 
>> Aaron Jensen <[email-masked]> writes:
>> 
>> > Is there anything specific to macOS that is involved in scrolling optimization?
>> 
>> Yes, Apple deleted the API used to perform bit blits, so Emacs uses a
>> workaround that I don't really understand, and seems unreliable.
>
> You mean, ns_scroll_run in nsterm.m?  Which parts of it do you not
> understand?

No, I meant the implementation of [EmacsView copyRect:] enabled under
Mac OS; see line 8655 of nsterm.m.  I don't understand how the system
synchronizes its access to the window's backing store with Emacs's.